SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Fakes'!
SystemOrganization addCategory: #'Monticello2-Squeak'!
SystemOrganization addCategory: #'Monticello2-Tests'!
SystemOrganization addCategory: #'Monticello2-Versions'!

TestCase subclass: #MDProxyTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDProxyTest methodsFor: 'constructing' stamp: 'avi 11/29/2004 14:13'!
updateVersion: anElementVersion property: aSymbol put: anObject
	| newSnapshot |
	newSnapshot _ anElementVersion snapshot copy.
	newSnapshot properties at: aSymbol put: anObject.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: anElementVersion fullAncestry! !

MDProxyTest subclass: #MDSliceTest
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 18:49'!
testSnapshot
	| slice snapshot |
	slice _ self slice.
	snapshot _ slice snapshotFrom: wc.
	slice do: [:element | self assert: (snapshot includesElement: element)]! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 21:19'!
testLoadWithDepenencies
	| snapshot |
	snapshot _ self snapshot.
	snapshot add: (self versionFor: #'Alpha/Delta' with: 'ad').
	self slice loadSnapshot: snapshot into: wc.
	self
		assert: (self atElement: (self element: #Alpha) property: #foo) = 'alpha';
		assert: (self atElement: (self element: #Beta) property: #foo) = 'beta';
		assert: (self atElement: (self element: #'Alpha/Delta') property: #foo) = 'ad'.! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 21:41'!
testLoadLargerSnapshot
	| slice alpha beta |
	alpha _ self element: #Alpha.
	beta _ self element: #Beta.
	slice _ MDExplicitSlice new.
	slice addElement: alpha.
	slice loadSnapshot: self snapshot into: wc.
	self assert: (self atElement: alpha property: #foo) = 'alpha'.
	self assert: (self atElement: beta property: #foo) = 'beta'.
	self assert: slice elements size = 1! !

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 2/27/2005 21:43'!
slice
	^ MDExplicitSlice new
		addElement: (self element: #Alpha);
		addElement: (self element: #Beta);
		yourself
	! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 21:48'!
testLoadSmallerSnapshot
	| alpha beta snapshot |
	alpha _ self element: #Alpha.
	beta _ self element: #Beta.
	snapshot _ MDSnapshot new.
	snapshot add: (self versionFor: #Alpha with: 'alpha').
	self slice loadSnapshot: snapshot into: wc.
	self assert: (self atElement: alpha property: #foo) = 'alpha'.
	self assert: (self atElement: beta property: #foo) isNil.
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 21:18'!
testLoadEqualSnapshot
	self slice loadSnapshot: self snapshot into: wc.
	self assert: (self atElement: (self element: #Alpha) property: #foo) = 'alpha'.
	self assert: (self atElement: (self element: #Beta) property: #foo) = 'beta'.! !

!MDSliceTest methodsFor: 'running' stamp: 'cwp 2/27/2005 18:47'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy! !

MDProxyTest subclass: #MDSnapshotTest
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSnapshotTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 19:15'!
testMergeNoOverlap
	| a b c |
	a _ self snapshot.
	b _ MDSnapshot new.
	b 
		add: (self versionFor: #Delta with: 'delta');
		add: (self versionFor: #Gamma with: 'gamma').
	c _ a merge: b.
	#(Alpha Beta Gamma Delta)
		do: [:ea | self assert: (c includesElement: (self element: ea))]
! !

!MDSnapshotTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 19:12'!
testMergeNoConflict
	| a b c |
	a _ self snapshot.
	b _ MDSnapshot new.
	a do: [:ea | b add: (self updateVersion: ea property: #bar put: 'bar')].
	c _ a merge: b.
	self assert: c size = 2.! !

!MDSnapshotTest methodsFor: 'running' stamp: 'cwp 2/13/2005 15:08'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy! !

!MDSnapshotTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 19:13'!
testMergeWithConflict
	| a b c base |
	a _ self snapshot.
	b _ self snapshot.
	base _ self version.
	a add: (self updateVersion: base property: #bar put: 'a').
	b add: (self updateVersion: base property: #baz put: 'b').
	c _ a merge: b.
	self assert: c size = 2.
	
	! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/13/2005 19:49'!
definition: aSymbol
	^ MDElementDefinition forElement: (self element: aSymbol)! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/5/2005 19:56'!
removal
	^ MDElementRemoval forElement: self element! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/13/2005 17:42'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/5/2005 19:57'!
version
	^ MDElementVersion snapshot: self definition! !

!MDProxyTest class methodsFor: 'testing' stamp: 'abc 2/13/2005 12:37'!
isAbstract
	^ self name = #MDProxyTest! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/27/2005 19:16'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/5/2005 19:56'!
definition
	^ MDElementDefinition forElement: self element! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/13/2005 19:51'!
removal: aSymbol
	^ MDElementRemoval forElement: (self element: aSymbol)! !

MDProxyTest subclass: #MDImageProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:38'!
testLoadAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	
	retrieved _ proxy updateSnapshot: self definition.
	self assert: original properties = retrieved properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:45'!
testRemoval
	| snap |
	self atElement: self element property: #foo put: 'bar'.
	snap _ self removal.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #foo) isNil! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 19:50'!
testNotLoadable
	| snap |
	snap _ self definition: #'Alpha/Delta'.
	snap properties at: #one put: 1.
	self deny: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:46'!
testRemovalUpToDate
	| snap removal |
	snap _ self definition.
	removal _ self removal.
	snap properties foo: 'bar'.
	proxy loadSnapshot: snap.
	self deny: (proxy isUpToDate: removal).
	proxy loadSnapshot: removal.
	self assert: (proxy isUpToDate: removal)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:43'!
testLoadDefinition
	| snap |
	snap _ self definition.
	snap properties 
			at: #one put: 1;
			at: #two put: 2;
			at: #three put: 3.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #one) = 1.
	self assert: (self atElement: self element property: #two) = 2.
	self assert: (self atElement: self element property: #three) = 3.! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:39'!
testLoadAndUpdateRemoval
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	retrieved _ proxy updateSnapshot: self removal.
	self assert: retrieved properties = original properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpToDate
	| snap |
	snap _ self definition.
	snap properties source: 'one ^ 1'.
	proxy loadSnapshot: snap.
	self assert: (proxy isUpToDate: snap).
	self atElement: self element property: #source put: 'one ^ 11'.
	self deny: (proxy isUpToDate: snap).! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:52'!
testCurrentDefinition
	| snap |
	self atElement: self element property: #one put: 1.
	snap := self definition.
	proxy updateSnapshot: snap.
	self assert: (snap properties at: #one) = 1
! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:44'!
testLoadRemoveAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	proxy loadSnapshot: self removal.
	retrieved _ proxy updateSnapshot: self definition.
	self assert: retrieved element = self element.
	self assert: retrieved isRemoval! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 19:36'!
testIsLoadable
	| snap |
	snap _ self definition.
	snap properties at: #one put: 1.
	self assert: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: ''!
testRemovalLoadable
	| snap |
	snap _ self removal: #'Alpha/Delta'.
	self assert: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpdateDoesntChangeElement
	| snap original |
	snap := self definition.
	original := snap element.
	proxy updateSnapshot: snap.
	self assert: snap element = original! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/27/2005 20:58'!
atElement: element property: property
	^ (proxy at: element) at: property ifAbsent: [nil]! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/27/2005 19:16'!
snapshot

	| snapshot |
	snapshot _ MDSnapshot new.
	snapshot
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta').
	^ snapshot! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/27/2005 19:16'!
versionFor: elementName with: value
	| element snapshot |
	element _ MDFakeElement named: elementName.
	snapshot _ MDElementDefinition forElement: element.
	snapshot properties at: #foo put: value.
	^ MDElementVersion snapshot: snapshot! !

!MDProxyTest methodsFor: 'constructing' stamp: 'cwp 2/13/2005 17:42'!
element
	^ self element: #Alpha! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:17'!
atProperty: aSymbol put: aValue
	self atElement: self element property: aSymbol put: aValue
! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/4/2005 23:54'!
atElement: element property: property put: value
	"This will need to be overriden in tests that use a real image proxy."
	
	(proxy at: element) at: property put: value! !

MDProxyTest subclass: #MDWorkingCopyTest
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 20:06'!
testSaveFirstVersion
	| version |
	self atElement: self element property: #foo put: 'one'.
	version _ wc versionForElement: self element.
	self assert: version ancestry isEmpty.
	self assert: version snapshot properties foo = 'one'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'.
! !

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'avi 11/29/2004 14:55'!
assertNoConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | self assert: false. ^self]! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 22:49'!
testLoadModifyAndSave
	| version newVersion |
	version := self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := wc versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion supersedes: version)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 22:49'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version := self version.
	version snapshot properties source: 'one'.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	newVersion2 := self 
				updateVersion: version
				property: #source
				put: 'three'.
	wc loadVersion: newVersion.
	wc includeVersion: newVersion2 onConflict: [:a :b | b snapshot].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion := wc versionForElement: version element.
	self assert: mergedVersion snapshot = newVersion2 snapshot.
	self assert: (mergedVersion supersedes: newVersion).
	self assert: (mergedVersion supersedes: newVersion2)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 21:56'!
testIncludeAbsentVersion
	| version |
	version _ self version.
	version snapshot properties foo: 'bar'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #foo) = 'bar'! !

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'avi 11/29/2004 14:55'!
assertConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | ^ self].
	self assert: false! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeNewVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkingCopyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:52'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:12'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	newVersion2 _ self updateVersion: version property: #source put: 'three'.
	wc loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:18'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self atProperty: #source put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 20:05'!
testLoadAndSave
	| version |
	version _ self version.
	version snapshot properties foo: '1'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testLoad
	| version |
	version _ self version.
	version snapshot properties foo: 'bar'.
	wc loadVersion: version.
	self assert: (self atProperty: #foo) = 'bar'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:17'!
testLoadOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	wc loadVersion: version.
	self assert: (self atProperty: #source) = 'one'.
! !

!MDProxyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:49'!
setUp
	proxy _ self proxyClass new! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:16'!
atProperty: aSymbol
	^ self atElement: self element property: aSymbol! !

!MDProxyTest methodsFor: 'configuration' stamp: 'cwp 2/4/2005 23:58'!
proxyClass
	^ MDFakeImageProxy! !

TestCase subclass: #MDAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/5/2005 20:53'!
tearDown
	self destroyObject! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 14:45'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)
! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 14:41'!
testNotUpToDate
	| properties |
	self propertyToChange ifNil: [^ self].
	self createObject.
	properties := self properties.
	properties at: self propertyToChange put: self changedValue.
	self deny: (self adaptor isUpToDate: properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:07'!
testNotPresent
	self deny: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:43'!
adaptor
	^ self adaptorForElement: self element! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 23:03'!
testUpdateSideEffects
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:49'!
bogusClass
	^ MDBogusA! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 23:54'!
testRemoveNotPresent
	self adaptor remove.
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:29'!
testIsUpToDate
	| method |
	self createObject.
	method := self adaptor.
	self assert: (method isUpToDate: self properties)! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2005 21:40'!
shouldInheritSelectors
	^ true! !

MDAdaptorTest subclass: #MDSqueakInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:07'!
denyObjectIsPresent
	self deny: self objectIsPresent! !

!MDSqueakInstVarAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 13:06'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeInstVarName: self instVarName]! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:26'!
element
	^ MDInstVarElement 
		className: self bogusClass name 
		name: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:24'!
createObject
	self bogusClass addInstVarName: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
objectIsPresent
	^self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
adaptorClass
	^ MDSqueakInstVarAdaptor! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:56'!
assertObjectHasDefaultProperties
	self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:21'!
instVarName
	^'two'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	"An instance variable has no properties, thus it is always up-to-date"

	^ nil! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
unloadableElement
	^ MDInstVarElement 
		className: #MDNonExistentClass
		name: self instVarName! !

MDAdaptorTest subclass: #MDSqueakClassAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 11:55'!
assertObjectHasDefaultProperties
	| class |
	class := Smalltalk 
			at: self bogusClassName 
			ifAbsent: [self signalFailure: 'Class doesn''t exist'].
	self assert: class superclass name = self superclassName.
	self assert: class category = self category.
	self assert: class typeOfClass = self format! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 12:03'!
category
	^ #'Monticello2-Fakes'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:15'!
commentStamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #category! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:18'!
properties
	^ MDPropertyDictionary new
		category: self category;
		format: self format;
		superclassName: self superclassName;
		yourself! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:14'!
commentTimeStamp
	^ TimeStamp fromMethodTimeStamp: self commentStamp! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 15:05'!
changedValue
	^ #temp! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 16:06'!
testClassMissing
	| properties |
	properties _ self properties.
	properties superclassName: #MDNonExistentClass.
	self deny: (self adaptor isLoadable: properties)! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:16'!
classInstVars
	^ 'aleph beth'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
format
	^ #normal! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:06'!
objectIsPresent
	^ Smalltalk hasClassNamed: self bogusClassName asString! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
classVariablesString
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:02'!
bogusClassName
	^ #MDBogusB! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:56'!
destroyObject
	(Smalltalk at: self bogusClassName ifAbsent: [^ self]) removeFromSystem! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
instanceVariablesString
	^'one two'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
superclassName
	^ #Object! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:08'!
createObject
	Object 
		subclass: self bogusClassName
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 12:05'!
testLoadingPreservesVars
	| class |
	self createObject.
	self adaptor load: self properties.
	class := Smalltalk at: self bogusClassName ifAbsent: [self assert: false].
	self assert: class instanceVariablesString = 'one two'.
	self assert: class classVariablesString = 'Alpha Beta'.
	self assert: class sharedPoolsString = self sharedPoolsString.! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:14'!
commentAuthor
	^ self commentStamp copyUpTo: $ ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:12'!
classVars
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 11:58'!
element
	^ MDClassElement className: self bogusClassName! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:13'!
comment
	^ 'A politician''s comment: it fills the space, while saying nothing.'! !

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:42'!
adaptorClass
	^ MDSqueakClassAdaptor ! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 23:52'!
sharedPoolsString
	^ 'MDBogusPoolA'! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 11:53'!
isAbstract
	^ self name = #MDAdaptorTest! !

MDAdaptorTest subclass: #MDSqueakMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:52'!
createObject
	self bogusClass
		compile: self source
		classified: self category
		withStamp: self stamp
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	^ #category! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:25'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:39'!
properties
	^ MDPropertyDictionary new
		author: self author;
		category: self category;
		source: self source;
		timeStamp: self timeStamp;
		yourself! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:24'!
category
	^ #temporary! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:06'!
changedValue
	^ #temp! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:07'!
objectIsPresent
	^self bogusClass includesSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:16'!
element
	^ MDMethodElement className: self bogusClass name selector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakMethodAdaptor! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:23'!
source
	^ 'method1
	^ 1'! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:14'!
theSelector
	^#method1! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:58'!
unloadableElement
	^ MDMethodElement className: #MDNonExistentClass selector: #foo! !

MDSqueakMethodAdaptorTest subclass: #MDSqueakClassMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassMethodAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2005 15:21'!
element
	^ MDMethodElement 
		className: super bogusClass name
		selector: self theSelector
		classIsMeta: true! !

!MDSqueakClassMethodAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2005 15:14'!
bogusClass
	^ super bogusClass class! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:15'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass includesSelector: self theSelector).
	self assert: (self bogusClass organization categoryOfElement: self theSelector) = self category.
	self assert: (self bogusClass sourceCodeAt: self theSelector) = self source.
	self assert: (self bogusClass compiledMethodAt: self theSelector) timeStamp = self stamp! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:15'!
destroyObject
	self bogusClass removeSelector: self theSelector! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 15:55'!
testClassMissing
	| adaptor |
	adaptor := self adaptorForElement: self unloadableElement.
	self deny: (adaptor isLoadable: self properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 14:08'!
testRemove
	self createObject.
	self adaptor remove.
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 22:54'!
testUpdate
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: properties = self properties! !

MDAdaptorTest subclass: #MDSqueakClassCommentAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:27'!
createObject
	self bogusClass classComment: self text stamp: self stamp
! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:20'!
element
	^ MDClassCommentElement className: self bogusClass name! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
text
	^ 'A comment for MDBogusA'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #text! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/12/2005 14:57'!
assertObjectHasDefaultProperties
	self assert: self bogusClass comment = self text.
	self assert: self bogusClass organization commentStamp = self stamp.! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:36'!
properties
	^ MDPropertyDictionary new
		at: #text put: self text;
		at: #author put: self author;
		at: #timeStamp put: self timeStamp;
		yourself! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 15:00'!
destroyObject
	self bogusClass organization classComment: nil stamp: nil! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:59'!
objectIsPresent
	^ self bogusClass hasComment! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:39'!
adaptorClass
	^ MDSqueakClassCommentAdaptor! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:18'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:51'!
changedValue
	^ 'A different comment for MDBogusA.'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^MDClassCommentElement className: #MDNonExistentClass! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:41'!
adaptorClass
	self subclassResponsibility! !

MDAdaptorTest subclass: #MDSqueakClassVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:46'!
propertyToChange
	"Class variables have no properties and thus can never by out of date."

	^ nil 
	! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
objectIsPresent
	^self bogusClass classVarNames includes: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:04'!
assertObjectHasDefaultProperties
	self assert: self objectIsPresent! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeClassVarName: self classVarName]! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
classVarName
	^ 'Beta'! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 13:31'!
createObject
	self bogusClass addClassVarName: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:46'!
element
	^ MDClassVarElement 
		className: self bogusClass name 
		name: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakClassVarAdaptor! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:01'!
unloadableElement
	^ MDClassVarElement className: #MDNonExistentClass name: #Foo! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
timeStamp
	^ TimeStamp fromMethodTimeStamp: self stamp! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
author
	^ self stamp copyUpTo: $ ! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 22:34'!
testLoad
	self adaptor load: self properties.
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 2/15/2005 15:56'!
unloadableElement
	self subclassResponsibility! !

MDAdaptorTest subclass: #MDSqueakPoolImportAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:57'!
pool
	^ Smalltalk at: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	"A pool import has no properties and is thus always up-to-date."
	^ nil! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^ MDPoolImportElement className: #MDNonExistentClass poolName: #Foo! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:04'!
adaptorClass
	^ MDSqueakPoolImportAdaptor! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:37'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:59'!
poolName
	^ #MDBogusPoolB! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 22:56'!
createObject
	self bogusClass addSharedPool: self pool! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:09'!
destroyObject
	self bogusClass sharedPools remove: self pool ifAbsent: []! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 23:45'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName])! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:46'!
objectIsPresent
	^ self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName]! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 23:30'!
element
	^ MDPoolImportElement className: self bogusClass name poolName: self poolName! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:41'!
adaptorForElement: anElement
	^ self adaptorClass forElement: anElement! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:42'!
testIsPresent
	self createObject.
	self assert: self adaptor isPresent! !

TestCase subclass: #MDHashstampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDHashstampTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 17:26'!
testCreation
	| hashstamp |
	hashstamp _ MDHashstamp hashIn: [:stream | stream nextPutAll: #(100 101 102)].
	self assert: hashstamp hash digitLength = 20.
	self assert: (DateAndTime now - hashstamp timestamp) asSeconds < 5.! !

!MDHashstampTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 17:35'!
testEqual
	| first second now |
	now _ TimeStamp now.
	first _ MDHashstamp hashIn: [:stream | stream nextPutAll: #(100 101 102)] timestamp: now.
	second _ MDHashstamp hashIn: [:stream | stream nextPutAll: #(100 101 102)] timestamp: now.
	self assert: first = second! !

!MDHashstampTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 17:37'!
testTimestamp
	| first second now then |
	now _ DateAndTime now.
	then _ now - (Duration seconds: 1).
	first _ MDHashstamp hashIn: [:stream | stream nextPutAll: #(100 101 102)] timestamp: then.
	second _ MDHashstamp hashIn: [:stream | stream nextPutAll: #(100 101 102)] timestamp: now.
	self assert: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 17:36'!
testHash
	| first second |
	first _ MDHashstamp hashIn: [:stream | stream nextPutAll: #(101 102 103)].
	second _ MDHashstamp hashIn: [:stream | stream nextPutAll: #(100 101 102)].
	self deny: first hash = second hash.
	self deny: first = second! !

TestCase subclass: #MDAdaptionTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDAdaptionTest subclass: #MDFakeAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:32'!
proxyClass
	^ MDFakeImageProxy! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 23:59'!
testPoolImportElement
	self tryAdapting: (MDPoolImportElement className: #MDBogusA poolName: #MDBogusPoolB)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:27'!
testInstVarElement
	self tryAdapting: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDAdaptionTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 22:14'!
adaptorSelectors
	^ #(isPresent isUpToDate: load: remove update:)! !

!MDAdaptionTest methodsFor: 'configuration' stamp: 'cwp 2/6/2005 22:10'!
proxyClass
	^ MDFakeImageProxy! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testClassElement
	self tryAdapting: (MDClassElement className: #MDBogusA)! !

!MDAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 22:33'!
isAbstract
	^ self name = #MDAdaptionTest! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
tryAdapting: anElement
	| adaptor |
	adaptor := anElement adaptedFor: proxy.
	self adaptorSelectors do: [:ea | self assert: (adaptor respondsTo: ea)].! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 2/6/2005 22:37'!
setUp
	proxy := self proxyClass new! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 13:59'!
testClassComment
	self tryAdapting: (MDClassCommentElement className: #MDBogusA)! !

MDAdaptionTest subclass: #MDSqueakAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:33'!
proxyClass
	^ MDSqueakImageProxy! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testMethodElement
	self tryAdapting: (MDMethodElement className: #MDBogusA selector: #method1)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:29'!
testClassVarElement
	self tryAdapting: (MDClassVarElement className: #MDBogusA name: 'Beta')! !

TestCase subclass: #MDMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMemoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 18:03'!
testStoreVersion
	| repository version |
	repository _ MDMemoryRepository new.
	version _ self version.
	repository storeVersion: version.
	self assert: (repository retrieveVersion: version hashstamp) == version! !

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 2/21/2005 20:25'!
version
	^ MDElementVersion 
		snapshot: (MDElementDefinition 
					forElement: (MDFakeElement 
									named: #Alpha))! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 11/29/2004 00:49'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector ifAbsent: [nil]].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

SharedPool subclass: #MDBogusPoolB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

SharedPool subclass: #MDBogusPoolA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

Object subclass: #MDSqueakElementAdaptor
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClassIfAbsent: aBlock
	^ Smalltalk at: element theClassName ifAbsent: aBlock! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:36'!
author
	^ self stamp copyUpTo: $ .! !

!MDSqueakElementAdaptor methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:39'!
propertyNames
	^ #()! !

!MDSqueakElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 16:55'!
setElement: anElement
	element _ anElement! !

MDSqueakElementAdaptor subclass: #MDSqueakClassCommentAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:34'!
stamp
	^ self elementClass organization commentStamp! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:59'!
remove
	self elementClass organization classComment: nil stamp: nil.
! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:55'!
load: properties
	self elementClass
		classComment: properties text
		stamp: (self stampFromProperties: properties)! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:29'!
text
	^ self elementClass comment! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:29'!
propertyNames
	^ #(text author timeStamp)! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:22'!
isPresent
	^ self elementClass hasComment! !

MDSqueakElementAdaptor subclass: #MDSqueakClassVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:49'!
isPresent
	^ self elementClass classVarNames includes: element name! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:59'!
remove
	self isPresent ifTrue: [self elementClass removeClassVarName: element name]! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 14:00'!
load: properties
	self isPresent ifFalse: [self elementClass addClassVarName: element name]! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:47'!
isLoadable: properties
	self elementClassIfAbsent: [^ false].
	^ true! !

MDSqueakElementAdaptor subclass: #MDSqueakPoolImportAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:41'!
load: properties
	self elementClass addSharedPool: self importedPool! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:44'!
remove
	"Work around a bug in Class>>removeSharedPool:"
	
	self elementClass sharedPools remove: self importedPool ifAbsent: []! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:34'!
isPresent
	^ self elementClass sharedPools anySatisfy: [:ea | ea name = element poolName]! !

!MDSqueakPoolImportAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 23:41'!
importedPool
	^ Smalltalk at: element poolName! !

MDSqueakElementAdaptor subclass: #MDSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:45'!
source
	^ self elementClass sourceCodeAt: (element selector).! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:06'!
category
	^ self elementClass organization categoryOfElement: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:45'!
load: properties
	self elementClass
		compile: (properties at: #source ifAbsent: [self source])
		classified: (properties at: #category ifAbsent: [self category])
		withStamp: (self stampFromProperties: properties)
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:44'!
compiledMethod 
	^ self elementClass compiledMethodAt: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:19'!
remove
	self elementClass removeSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:30'!
stamp
	^self compiledMethod timeStamp! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:12'!
propertyNames
	^ #(author timeStamp category source)! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:24'!
elementClassIfAbsent: aBlock
	| nonMetaClass |
	nonMetaClass := super elementClassIfAbsent: aBlock.
	^ element classIsMeta
		ifTrue: [nonMetaClass class]
		ifFalse: [nonMetaClass]! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:22'!
isPresent
	^ self elementClass includesSelector: element selector! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:40'!
isUpToDate: properties 
	self propertyNames
		do: [:property | (self is: property upToDateIn: properties) ifFalse: [^ false]].
	^ true
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
remove
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:31'!
timeStamp
	^TimeStamp fromMethodTimeStamp: self stamp! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClass
	^ self elementClassIfAbsent: [nil]! !

MDSqueakElementAdaptor subclass: #MDSqueakClassAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:31'!
sharedPoolsString
	^ self send: #sharedPoolsString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/15/2005 15:05'!
superclassFrom: properties ifAbsent: absentBlock 
	| global |
	global _ Smalltalk 
				at: properties superclassName 
				ifAbsent: [^ absentBlock value].
	^ (global isKindOf: Class)
		ifTrue: [global]
		ifFalse: absentBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
elementClass
	^ Smalltalk at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/5/2005 23:02'!
propertyNames
	^ #(category format superclassName)! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:31'!
isLoadable: properties 
	self superclassFrom: properties ifAbsent: [^ false].
	^ true! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 22:25'!
load: properties
	| superClass |
	superClass _ Smalltalk at: properties superclassName.
	ClassBuilder new
		name: element theClassName 
		inEnvironment: superClass environment 
		subclassOf: superClass
		type: properties format 
		instanceVariableNames: self instanceVariablesString 
		classVariableNames: self classVariablesString 
		poolDictionaries: self sharedPoolsString
		category: properties category
! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
format
	^ self elementClass typeOfClass! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
send: aSelector toClassIfNil: aBlock
	| class |
	class := self elementClass.
	^ class 
		ifNotNil: [class perform: aSelector]
		ifNil: aBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
classVariablesString
	^ self send: #classVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
instanceVariablesString
	^ self send: #instanceVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:40'!
superclassName
	^ self elementClass superclass name! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
category
	^ self elementClass category! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:23'!
isPresent
	^ (Smalltalk at: element theClassName ifAbsent: [^ false])
		isKindOf: Class! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:32'!
theClass
	^ Smalltalk at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:39'!
remove
	self elementClass ifNotNilDo: [:class | class removeFromSystem]! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/12/2005 14:52'!
stampFromProperties: properties
	| author timestamp |
	author _ properties at: #author ifAbsent: ['<nobody>'].
	timestamp _ properties at: #timeStamp ifAbsent: [^ '<no timestamp>'].
	^ String streamContents: 
		[:stream |
		stream nextPutAll: author.
		stream nextPut: $ .
	 	timestamp asDate printOn: stream format: #(2 1 3 $/ 1 1).
		stream nextPut: $ .
		timestamp asTime print24: true showSeconds: false on: stream]
		! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
load: properties
	self subclassResponsibility! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 20:56'!
forElement: anElement
	^ self new setElement: anElement! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 21:40'!
is: name upToDateIn: properties
	^ (properties at: name ifAbsent: [^ true]) = (self perform: name)
	! !

MDSqueakElementAdaptor subclass: #MDSqueakInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:50'!
isPresent
	^ self elementClass instVarNames includes: element name! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:56'!
remove
	self isPresent ifTrue: [self elementClass removeInstVarName: element name]! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:56'!
load: properties
	self isPresent ifFalse: [self elementClass addInstVarName: element name]! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 15:04'!
update: properties
	self propertyNames do: [:name | properties at: name put: (self perform: name)]! !

Object subclass: #MDVersion
	instanceVariableNames: 'hashstamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDVersion methodsFor: 'comparing' stamp: 'cwp 2/27/2005 22:49'!
supersedes: anElementVersion 
	^anElementVersion isSupersededBy: self! !

!MDVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:20'!
hashstamp
	^ hashstamp! !

MDVersion subclass: #MDElementVersion
	instanceVariableNames: 'snapshot ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersion methodsFor: 'initialize-release' stamp: 'cwp 2/27/2005 18:04'!
initializeWithSnapshot: elementSnapshot ancestry: aCollection
	snapshot _ elementSnapshot.
	ancestry _ aCollection.
	hashstamp _ MDHashstamp hashIn: 
		[:stream |
		elementSnapshot storeOn: stream.
		ancestry storeOn: stream].
! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:17'!
snapshot
	^ snapshot! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
snapshot: anElementSnapshot
	^ self snapshot: anElementSnapshot ancestry: Set new! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:01'!
fullAncestry
	^ ancestry copyWith: hashstamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:39'!
element
	^ snapshot element! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:31'!
snapshot: anElementSnapshot ancestry: aSet
	^ self basicNew initializeWithSnapshot: anElementSnapshot ancestry: aSet! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

!MDElementVersion methodsFor: 'comparing' stamp: 'cwp 2/27/2005 22:49'!
isSupersededBy: aVersion 
	^aVersion ancestry includes: hashstamp! !

MDVersion subclass: #MDNullVersion
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
ancestry
	^ Set new! !

!MDNullVersion methodsFor: 'initialize-release' stamp: 'cwp 2/27/2005 21:31'!
setElement: anElement
	element _ anElement.
	hashstamp _ MDHashstamp 
					hashIn: [:stream | stream nextPutAll: element storeString]
					timestamp: TimeStamp epoch! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:36'!
element
	^ element! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:35'!
snapshot
	^ MDElementRemoval forElement: element! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
fullAncestry
	^ Set new! !

!MDNullVersion class methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 21:31'!
forElement: anElement
	^ self new setElement: anElement! !

!MDNullVersion methodsFor: 'comparing' stamp: 'cwp 2/27/2005 22:49'!
isSupersededBy: anElementVersion 
	^true! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/3/2005 23:56'!
hasElement: anElement
	^ (anElement adaptedFor: self) isPresent! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/13/2005 19:39'!
isLoadable: anElementSnapshot
	^ anElementSnapshot isLoadableInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:07'!
loadSnapshot: aSnapshot
	aSnapshot loadInto: self! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForInstVarElement: anElement
	^ MDSqueakInstVarAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForClassElement: anElement
	^ MDSqueakClassAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/7/2005 00:00'!
adaptorForPoolImportElement: anElement
	^ MDSqueakPoolImportAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForMethodElement: anElement
	^ MDSqueakMethodAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForClassVarElement: anElement
	^ MDSqueakClassVarAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/12/2005 14:06'!
adaptorForClassCommentElement: anElement
	^ MDSqueakClassCommentAdaptor forElement: anElement! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/29/2004 13:26'!
isUpToDate: anElementSnapshot
	^ anElementSnapshot isUpToDateFor: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/27/2005 22:00'!
updateSnapshot: anElementSnapshot
	^ anElementSnapshot updateFrom: self! !

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForClassVarElement: anClassVarElement
	^ self adaptorForElement: anClassVarElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:23'!
removeKey: anElement
	dict removeKey: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:04'!
adaptorForClassCommentElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:28'!
includesKey: anElement 
	^ dict includesKey: anElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/5/2005 16:08'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]
! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForInstVarElement: anInstVarElement
	^ self adaptorForElement: anInstVarElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForElement: anElement 
	^ MDFakeElementAdaptor
		forElement: anElement
		inImage: dict! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/7/2005 00:01'!
adaptorForPoolImportElement: aPoolImportElement 
	^ self adaptorForElement: aPoolImportElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForMethodElement: aMethodElement 
	^ self adaptorForElement: aMethodElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:18'!
adaptorForClassElement: aClassElement 
	^ self adaptorForElement: aClassElement! !

Object subclass: #MDFakeElementAdaptor
	instanceVariableNames: 'image element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:29'!
checkDependencies
	self isLoadable ifFalse: [self error: 'Unmet dependency']! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:39'!
isUpToDate: properties
	properties keysAndValuesDo: 
		[:key :value |
		(self properties at: key ifAbsent: [^ false]) = value ifFalse: [^ false]].
	^ true
	! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:31'!
isLoadable
	| required |
	(element name includes: $/) ifFalse: [^ true].
	required := element name copyUpTo: $/.
	^ image keys anySatisfy: [:ea | ea name = required]
! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:33'!
update: properties
	self properties keysAndValuesDo: [:key :value | properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 18:16'!
load: properties 
	self checkDependencies.
	properties keysAndValuesDo: [:key :value | self properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/4/2005 00:34'!
setImage: aFakeImageProxy element: anElement
	image _ aFakeImageProxy.
	element _ anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 19:44'!
isLoadable: properties
	^ self isLoadable! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:36'!
isPresent
	^ image includesKey: element! !

!MDFakeElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/13/2005 18:17'!
properties
	^ image at: element ifAbsentPut: [Dictionary new]! !

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/4/2005 00:35'!
forElement: anElement inImage: aDictionary
	^ self new setImage: aDictionary element: anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:40'!
remove
	image removeKey: element ifAbsent: []! !

Object subclass: #MDBogusA
	instanceVariableNames: 'one Beta'
	classVariableNames: 'Alpha'
	poolDictionaries: 'MDBogusPoolA'
	category: 'Monticello2-Fakes'!

Object subclass: #MDHashstamp
	instanceVariableNames: 'hash timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 2/27/2005 17:34'!
= other
	self class = other class ifFalse: [^ false].
	self hash = other hash ifFalse: [^ false].
	^ self timestamp = other timestamp! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 2/27/2005 17:17'!
timestamp
	^ timestamp! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 2/27/2005 17:17'!
hash
	^ hash! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 2/27/2005 17:16'!
setHash: aLargeInteger timestamp: aTimeStamp
	hash _ aLargeInteger.
	timestamp _ aTimeStamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 2/27/2005 18:07'!
hashIn: aBlock timestamp: aTimestamp
	| sha stream |
	stream _ RWBinaryOrTextStream on: ByteArray new.
	aBlock value: stream.
	sha _ SecureHashAlgorithm new.
	^ self new setHash: (sha hashMessage: stream contents) timestamp: aTimestamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 2/27/2005 17:30'!
hashIn: aBlock
	^ self hashIn: aBlock timestamp: TimeStamp now! !

Object subclass: #MDMemoryRepository
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 2/21/2005 20:22'!
retrieveVersion: aVersionId
	^ versions at: aVersionId! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 2/27/2005 18:03'!
storeVersion: anElementVersion
	versions at: anElementVersion hashstamp put: anElementVersion! !

!MDMemoryRepository methodsFor: 'initialize-release' stamp: 'cwp 2/21/2005 20:20'!
initialize
	versions _ Dictionary new.! !

Object subclass: #MDSnapshot
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDSnapshot methodsFor: 'testing' stamp: 'cwp 2/13/2005 15:17'!
includesElement: anElement
	^ versions anySatisfy: [:version | version element = anElement]! !

!MDSnapshot methodsFor: 'working copy' stamp: 'cwp 2/21/2005 16:50'!
merge: aSnapshot
	| result |
	result _ MDSnapshot new.
	versions do: [:ea | result add: ea].
	aSnapshot do: [:ea | result add: ea].
	^ result! !

!MDSnapshot methodsFor: 'working copy' stamp: 'cwp 2/21/2005 16:32'!
loadInto: aWorkingCopy

	| loading unloaded |	
	unloaded _ versions.
	[loading _ unloaded.
	unloaded _ self loadVersions: loading into: aWorkingCopy.
	loading size > unloaded size] whileTrue.
	
! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:34'!
versions
	^ versions values asSet! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 2/21/2005 18:13'!
size
	^ versions size! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 2/13/2005 15:51'!
do: aBlock
	^ versions do: aBlock! !

!MDSnapshot methodsFor: 'private' stamp: 'cwp 2/21/2005 16:27'!
loadVersions: loading into: aWorkingCopy 
	| unloadable |
	unloadable _ Set new.
	loading do: [:ea | aWorkingCopy 
						loadVersion: ea 
						ifUnloadable: [unloadable add: ea]].
	^ unloadable! !

!MDSnapshot methodsFor: 'initialize-release' stamp: 'cwp 2/21/2005 18:14'!
initialize
	versions _ Dictionary new.! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 2/21/2005 18:14'!
add: anElementVersion 
	versions at: anElementVersion element put: anElementVersion! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
is: properties upToDateFor: anImageProxy
	^ (self adaptedFor: anImageProxy) isUpToDate: properties! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
update: properties from: anImageProxy
	^ (self adaptedFor: anImageProxy) update: properties! !

MDImageElement subclass: #MDClassCommentElement
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassCommentElement methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:03'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassCommentElement: self! !

!MDClassCommentElement methodsFor: 'initialize-release' stamp: 'cwp 2/12/2005 14:01'!
setClassName: aSymbol 
	className := aSymbol! !

!MDClassCommentElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol 
	^ self basicNew setClassName: aSymbol! !

!MDClassCommentElement methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:23'!
theClassName
	^ className! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

MDImageElement subclass: #MDClassVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassVarElement methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:31'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassVarElement: self! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
name
	^ name! !

!MDClassVarElement class methodsFor: 'intance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDClassVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 13:48'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
theClassName
	^ theClassName! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
removeFrom: anImageProxy
	^ (self adaptedFor: anImageProxy) remove! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

MDImageElement subclass: #MDInstVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDInstVarElement methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:28'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForInstVarElement: self! !

!MDInstVarElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:49'!
theClassName
	^ theClassName! !

!MDInstVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 12:27'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:52'!
name
	^ name! !

MDImageElement subclass: #MDMethodElement
	instanceVariableNames: 'theClassName selector classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:22'!
theClassName
	^theClassName! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'cwp 2/12/2005 15:15'!
setClassName: aString selector: aSymbol classIsMeta: aBoolean
	theClassName := aString.
	selector := aSymbol.
	classIsMeta := aBoolean! !

!MDMethodElement methodsFor: 'converting' stamp: 'cwp 2/3/2005 22:09'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForMethodElement: self! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aString selector: aSymbol 
	^self className: aString selector: aSymbol classIsMeta: false! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:25'!
classIsMeta
	^ classIsMeta! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 21:23'!
= other 
	^self class = other class and: [theClassName = other theClassName]
		and: [self selector = other selector]! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:16'!
className: aString selector: aSymbol classIsMeta: aBoolean
	^self basicNew setClassName: aString selector: aSymbol classIsMeta: aBoolean! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 21:22'!
hash
	^(theClassName , '|' , selector) hash! !

MDImageElement subclass: #MDPoolImportElement
	instanceVariableNames: 'theClassName poolName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPoolImportElement methodsFor: 'converting' stamp: 'cwp 2/7/2005 00:01'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForPoolImportElement: self! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
poolName
	^ poolName! !

!MDPoolImportElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 23:13'!
setClassName: classNameSymbol poolName: poolNameSymbol
	theClassName := classNameSymbol.
	poolName := poolNameSymbol! !

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: classNameSymbol poolName: poolNameSymbol
	^ self basicNew setClassName: classNameSymbol poolName: poolNameSymbol! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
theClassName
	^ theClassName! !

!MDImageElement methodsFor: 'testing' stamp: 'cwp 2/4/2005 23:48'!
isMethodElement
	^ false! !

MDImageElement subclass: #MDClassElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassElement methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 21:27'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassElement methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:20'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassElement: self! !

!MDClassElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol
	^ self basicNew setClassName: aSymbol! !

!MDClassElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:28'!
theClassName
	^ theClassName! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:42'!
isLoadable: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) isLoadable: properties
! !

!MDImageElement methodsFor: 'adapting' stamp: 'cwp 2/3/2005 23:54'!
adaptedFor: anImageProxy
	self subclassResponsibility! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
load: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) load: properties
! !

MDImageElement subclass: #MDFakeElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name: aSymbol
	name _ aSymbol! !

!MDFakeElement class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 19:02'!
named: aSymbol
	^ self new name: aSymbol! !

!MDFakeElement methodsFor: 'public' stamp: 'cwp 2/5/2005 19:03'!
adaptedFor: anImageProxy 
	^ anImageProxy adaptorForElement: self! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
= other
	self species = other species ifFalse: [^ false].
	^ self name = other name! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
hash
	^ name hash! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name
	^ name! !

Object subclass: #MDElementRemoval
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementRemoval class methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:23'!
forElement: anImageElement
	^ self basicNew initializeWithElement: anImageElement! !

!MDElementRemoval methodsFor: 'initialize-release' stamp: 'avi 12/2/2004 01:23'!
initializeWithElement: anImageElement
	element _ anImageElement! !

!MDElementRemoval methodsFor: 'load and save' stamp: 'avi 12/2/2004 01:51'!
updateFrom: anImageProxy
	^ (MDElementDefinition forElement: element) updateFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ true! !

!MDElementRemoval methodsFor: 'testing' stamp: 'avi 12/2/2004 01:56'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element) not! !

!MDElementRemoval methodsFor: 'load and save' stamp: 'avi 12/2/2004 01:27'!
loadInto: anImageProxy
	element removeFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'accessing' stamp: 'avi 12/2/2004 01:54'!
element
	^ element! !

!MDElementRemoval methodsFor: 'load and save' stamp: 'cwp 2/13/2005 19:52'!
isLoadableInto: anImageProxy
	"Removals are always loadable."
	
	^ true! !

Object subclass: #MDSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDSlice methodsFor: 'working copy' stamp: 'cwp 2/27/2005 21:21'!
loadSnapshot: aSnapshot into: aWorkingCopy
	| loading unloaded |	
	unloaded _ self expandVersions: aSnapshot versions.
	[loading _ unloaded.
	unloaded _ self loadVersions: loading into: aWorkingCopy.
	loading size > unloaded size] whileTrue.
	! !

!MDSlice methodsFor: 'private' stamp: 'cwp 2/27/2005 21:31'!
expandVersions: versions
	| existingElements result |
	existingElements _ versions collect: [:ea | ea element]. 
	result _ versions copy.
	self do: [:el | (existingElements includes: el) 
					ifFalse: [result add: (MDNullVersion forElement: el)]].
	^ result! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 19:08'!
elements
	| result |
	result _ Set new.
	self do: [:ea | result add: ea].
	^ result! !

!MDSlice methodsFor: 'working copy' stamp: 'cwp 2/27/2005 18:59'!
snapshotFrom: aWorkingCopy
	
	| snapshot |
	snapshot _ MDSnapshot new.
	self do: [:ea | snapshot add: (aWorkingCopy versionForElement: ea)].
	^ snapshot! !

!MDSlice methodsFor: 'enumerating' stamp: 'cwp 2/27/2005 22:54'!
do: aBlock
	self subclassResponsibility! !

!MDSlice methodsFor: 'private' stamp: 'cwp 2/27/2005 21:16'!
loadVersions: loading into: aWorkingCopy 
	| unloadable |
	unloadable _ Set new.
	loading do: [:ea | aWorkingCopy 
						loadVersion: ea 
						ifUnloadable: [unloadable add: ea]].
	^ unloadable! !

MDSlice subclass: #MDExplicitSlice
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDExplicitSlice methodsFor: 'enumerating' stamp: 'cwp 2/27/2005 18:57'!
do: aBlock	
	^ elements do: aBlock! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:54'!
addElement: anElement
	elements add: anElement! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 2/27/2005 18:53'!
initialize
	elements _ Set new! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ false! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'avi 11/29/2004 13:27'!
isUpToDateFor: anImageProxy
	^ element is: properties upToDateFor: anImageProxy! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'avi 12/2/2004 01:53'!
updateFrom: anImageProxy
	(anImageProxy hasElement: element) ifFalse: [^ MDElementRemoval forElement: element].
	element update: properties from: anImageProxy.
	^ self! !

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/29/2004 00:50'!
initializeWithElement: anElement
	element _ anElement.
	properties _ MDPropertyDictionary new! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:41'!
isLoadableInto: anImageProxy
	^ element isLoadable: properties into: anImageProxy! !

!MDElementDefinition methodsFor: 'copying' stamp: 'avi 11/29/2004 14:16'!
copy
	| new |
	new _ self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

Object subclass: #MDWorkingCopy
	instanceVariableNames: 'proxy versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDWorkingCopy methodsFor: 'private' stamp: 'avi 11/29/2004 13:53'!
newVersionForElement: anImageElement
	| oldVersion newSnapshot |
	oldVersion _ versions at: anImageElement.
	newSnapshot _ oldVersion snapshot copy.
	proxy updateSnapshot: newSnapshot.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: oldVersion fullAncestry! !

!MDWorkingCopy methodsFor: 'versions' stamp: 'cwp 2/13/2005 15:29'!
versionForElement: anImageElement
	| old |
	old _ versions 
			at: anImageElement 
			ifAbsent: [^ self createVersionForElement: anImageElement].
	^ (proxy isUpToDate: old snapshot)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anImageElement]! !

!MDWorkingCopy methodsFor: 'private' stamp: 'avi 11/29/2004 15:01'!
resolveConflictBetween: oldVersion and: newVersion using: aBlock
	| mergedSnapshot mergedVersion |
	mergedSnapshot _ aBlock value: oldVersion value: newVersion.
	mergedVersion _ MDElementVersion
						snapshot: mergedSnapshot
						ancestry: (oldVersion fullAncestry, newVersion fullAncestry).
	self loadVersion: mergedVersion! !

!MDWorkingCopy methodsFor: 'versions' stamp: 'cwp 2/21/2005 16:28'!
loadVersion: anElementVersion
	^ self 
		loadVersion: anElementVersion 
		ifUnloadable: [self error: 'Unable to load element version.']! !

!MDWorkingCopy methodsFor: 'versions' stamp: 'cwp 2/27/2005 22:49'!
includeVersion: anElementVersion onConflict: twoArgBlock 
	| currentVersion |
	currentVersion := self versionForElement: anElementVersion element.
	(anElementVersion supersedes: currentVersion) 
		ifTrue: 
			[self loadVersion: anElementVersion.
			^true].
	(currentVersion supersedes: anElementVersion) ifTrue: [^false].
	self 
		resolveConflictBetween: currentVersion
		and: anElementVersion
		using: twoArgBlock.
	^true! !

!MDWorkingCopy methodsFor: 'initialize-release' stamp: 'avi 11/29/2004 13:40'!
initializeWithImageProxy: anImageProxy
	proxy _ anImageProxy.
	versions _ Dictionary new! !

!MDWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 12:56'!
forImageProxy: anImageProxy
	^ self basicNew initializeWithImageProxy: anImageProxy! !

!MDWorkingCopy methodsFor: 'versions' stamp: 'cwp 2/21/2005 16:25'!
loadVersion: anElementVersion ifUnloadable: aBlock
	(proxy isLoadable: anElementVersion snapshot) ifFalse: [^ aBlock value].
	versions at: anElementVersion element put: anElementVersion.
	proxy loadSnapshot: anElementVersion snapshot! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 2/27/2005 22:09'!
createVersionForElement: anElement 
	| snapshot version |
	(proxy hasElement: anElement) ifFalse: [^ MDNullVersion forElement: anElement].
	snapshot _ (MDElementDefinition forElement: anElement) updateFrom: proxy.
	version _ MDElementVersion snapshot: snapshot.
	versions at: anElement put: version.
	^ version! !
